% P12segments.m
% code to create figures for post 12
%  REA 2011-Aug-30 11:16
%  COPYRIGHT:   Aprend Technology, 2011. All rights reserved. 

%%  intersect of 2 lines
zseg = [0 1i]; % line along the y axis
p1 = [-.5 .5] + 0.5*1i; % line segment parallel to x-axis at y=0.5
zi = PolylineIntersectSegment(zseg,p1);
disp(zi)

%% add another segment along same direction as first one but of zero length
% only chooses the intersection with the correct segment
p1null = [p1, p1(end)];
zi = PolylineIntersectSegment(zseg,p1null);
disp(zi)

%% add another segment along same direction as first one
% only chooses the intersection with the correct segment
p2 = [p1, (1.5+0.5i)];
zi = PolylineIntersectSegment(zseg,p2);
disp(zi)

%% add segment parallel to test segment in y-direction
% ignores segments to test segment
p3 = [p2,(1.5+2i)];
zi = PolylineIntersectSegment(zseg,p3);
disp(zi)

%% display results
fh = figure;
plot(p3,'-xb')
hold on
plot(zseg,'-rd')
plot(zi,'ok')
hold off
axis([-2 2 -2 2])
%% intersection with a square
zseg = [1, 1i];
psquare = [0 1, 1+1i, 1i];
poff = 1.5*(psquare - (0.5+0.5*1i)); % center square at origin
zi = PolylineIntersectSegment(zseg,poff);
  % display the results
fh = figure;  
plot(poff,'-xb')
hold on
plot(zseg,'-rd','linewidth',1.3)
plot(zi,'ok')
hold off
axis([-1 1 -1 1])
hlabel = LabelPointsZ(gca,poff);
set(gca,'linewidth',1.3,'fontsize',12);
set(fh,'color','w','position',[250 250 550 450])

%% export the figure as png and eps
dirname = 'E:\Projects\Blog\Posts\P12segments\'; % edit this for your computer
figno = sprintf('-f%d',fh);
fname = 'IntersectExample';
print(figno,[dirname fname '.png'],'-dpng','-cmyk','-r100') % resolution 100 dpi
   % export as eps
print(figno,[dirname fname '.eps'],'-deps','-cmyk') 